<?php /*
Plugin Name: SmiliesSupport
Version: 0.5
Description: Allow add Smilies for comments and descriptions. / Permet d'ajouter des Smilies pour les commentaires et les descriptions.
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=159
Author: Atadilo
Author URI: http://www.phpwebgallery.net
*/
	global $conf;
  
	if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
	
	if ( (!isset($conf['smiliessupport'])) or (substr_count($conf['bbcode_bar'] , ',') != 3) ){
		$conf['smiliessupport'] = 'plugins/SmiliesSupport/smilies,5,sourire.gif';
		include_once('plugins/SmiliesSupport/maintain.inc.php');
		plugin_install();
	}
	
	// Init
	add_event_handler('init', 'set_smiliessupport_render' );	
	// Fonction d'initalisation
	function set_smiliessupport_render () {	
		global $template;			

		// On enleve le 'render_comment_content' pour le remplacer par un qui va traiter le BBCode
		remove_event_handler('render_comment_content', 'parse_comment_content' );
		add_event_handler('render_comment_content', 'CompleteWithSmilies', 60, 1 );
		
		// Ajout du renderer des catgories
		add_event_handler('render_cat_description', 'htmlspecialchars');
		add_event_handler('render_cat_description', 'CompleteWithSmilies', 50, 1 );
		
		// Ajout du renderer des descriptions des lments
		add_event_handler('render_element_description', 'htmlspecialchars');
		add_event_handler('render_element_description', 'CompleteWithSmilies', 50, 1 );
		
	}
	
	add_event_handler('loc_end_page_header', 'set_smiliessupport_page_css' );	
	function set_smiliessupport_page_css () {
		global $template;	
		$content = '<link rel="stylesheet" type="text/css" href="'.PHPWG_PLUGINS_PATH.'SmiliesSupport/smiliessupport_page.css" >';	
		$template->assign_block_vars( 'head_element', array( 'CONTENT' => $content, ) );		
	}
	
	add_event_handler('loc_end_picture', 'set_smiliessupport_page', 50, 1 );
		
	// Fonction qui ajoute la BBCode bar
	function set_smiliessupport_page($content) {
		
		global $conf, $template;
					
		$template->assign_vars( array('formname' => 'addComment') );
		$template->assign_vars( array('textareaname' => 'content') );
		
		$tlp_handle = 'picture';
		$old = '{lang:comment}';
		$new = '{SMILIESSUPPORT_PAGE}';
		
		$template->loadfile($tlp_handle);
		$template->uncompiled_code[$tlp_handle] = str_replace($old, $old.$new, $template->uncompiled_code[$tlp_handle]);
		
		//addSmiliesTable();
	}
	
	include_once(dirname(__FILE__) . '/smiliessupport_page.php');
	add_event_handler('loc_end_picture', 'addSmiliesTable', 60 );
	
	function CompleteWithSmilies($comment) {
		global $conf, $page;
		
		$conf_smiliessupport = explode("," , $conf['smiliessupport']);
		
		$def_path = $conf_smiliessupport[0].'/smilies.txt';
		if ( file_exists($def_path) )
		{
			$def = file($def_path);
			
			foreach($def as $v)
			{
				$v = trim($v);
				if (preg_match('|^([^\t]*)[\t]+(.*)$|',$v,$matches))
				{
					$r[] = '/(\A|[\s]+|>)('.preg_quote($matches[1],'/').')([\s]+|[<]|\Z)/ms';					
					$s[] = '<img src="'.$conf_smiliessupport[0].'/'.$matches[2].'" '.'alt="$2" title="$2" />';
					
					$comment = preg_replace($r, $s, $comment);
				}
						
			}
			
		} 
		if ($handle = opendir(PHPWG_ROOT_PATH.$conf_smiliessupport[0])) {
		
			while (false !== ($file = readdir($handle))) {
				
				if ($file != "." && $file != ".." && ( get_extension($file) == "gif" || get_extension($file) == "png")) {
					$v = ':'.get_filename_wo_extension($file).':';
									
					$s = '<img src="'.$conf_smiliessupport[0].'/'.$file.'" '.'alt="'.get_filename_wo_extension($file).'" title="'.get_filename_wo_extension($file).'" />';
						
					$comment = str_replace($v, $s, $comment);
					
				}
			}
		}
		return $comment;
	} 
	
	// Ajout du menu d'admin
	function smiliessupport_admin_menu($menu) {
	    array_push($menu,
	        array('NAME' => 'SmiliesSupport',
	            'URL' => get_admin_plugin_menu_link(dirname(__FILE__) . '/smiliessupport_admin.php')
	            )
	        );
	    return $menu;
	}
	add_event_handler('get_admin_plugin_menu_links', 'smiliessupport_admin_menu');
	
		
?>
